%{?scl:%{?scl_package:%scl_package strace}}

Summary: Tracks and displays system calls associated with a running process
Name: %{?scl_prefix}strace
Version: 4.7
Release: 11%{?dist}
License: BSD
Group: Development/Debuggers
URL: http://sourceforge.net/projects/strace/
# The upstream source really comes in .xz format.  Unfortunately
# DTS builds using .xz seem to want to use /opt/rh/<...>/xz rather
# than the one in /usr/bin.  Using the .gz extension seems to avoid
# this problem.  This should be fixed at some point.
Source: http://downloads.sourceforge.net/strace/strace-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%define alternatives_cmd %{!?scl:%{_sbindir}}%{?scl:%{_root_sbindir}}/alternatives
%define alternatives_cmdline %{alternatives_cmd}%{?scl: --altdir %{_sysconfdir}/alternatives --admindir %{_scl_root}/var/lib/alternatives}

BuildRequires: libacl-devel, libaio-devel, time
%{?scl:Requires:%scl_runtime}

Patch1000: strace-strict-aliasing.patch
Patch1001: strace-rh915181.patch
Patch1002: strace-rh851457.patch
Patch1003: strace-rh845004.patch
Patch1004: strace-rh921550.patch
Patch1005: strace-rh971352.patch


%define strace64_arches ppc64 sparc64

%description
The strace program intercepts and records the system calls called and
received by a running process.  Strace can print a record of each
system call, its arguments and its return value.  Strace is useful for
diagnosing problems and debugging, as well as for instructional
purposes.

Install strace if you need a tool to track the system calls made and
received by a process.

%ifarch %{strace64_arches}
%package -n strace64
Summary: Tracks and displays system calls associated with a running process.
Group: Development/Debuggers

%description -n strace64
The strace program intercepts and records the system calls called and
received by a running process.  Strace can print a record of each
system call, its arguments and its return value.  Strace is useful for
diagnosing problems and debugging, as well as for instructional
purposes.

Install strace if you need a tool to track the system calls made and
received by a process.

This package provides the `strace64' program to trace 64-bit processes.
The `strace' program in the `strace' package is for 32-bit processes.
%endif

%prep
%setup -q -n strace-%{version}
%patch1000 -p1
%patch1001 -p1
%patch1002 -p1
%patch1003 -p1
%patch1004 -p1
%patch1005 -p1

%build
%configure
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} install

# remove unpackaged files from the buildroot
rm -f %{buildroot}%{_bindir}/strace-graph

%define copy64 ln
%if 0%{?rhel}
%if 0%{?rhel} < 6
%endif
%define copy64 cp -p
%endif

%ifarch %{strace64_arches}
%{copy64} %{buildroot}%{_bindir}/strace %{buildroot}%{_bindir}/strace64
%endif

%check
make check

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc CREDITS ChangeLog ChangeLog-CVS COPYRIGHT NEWS README
%{_bindir}/strace
%{_bindir}/strace-log-merge
%{_mandir}/man1/*

%ifarch %{strace64_arches}
%files -n strace64
%defattr(-,root,root)
%{_bindir}/strace64
%endif

%changelog
* Thu Jun 13 2013 Jeff Law <law@redhat.com> 4.7-11
  - Unconditionally define MADV_DUMP and MADV_DONTDUMP as
    DTS is built on RHEL 6.2 which doesn't define them (#921550).

* Wed Jun 12 2013 Jeff Law <law@redhat.com> 4.7-10
  - Don't dereference dropped TCP (#971352).  From
  Jan Stancek.

* Fri Mar 29 2013 Jeff Law <law@redhat.com> 4.7-9
  - Rebuild with new build roots

* Thu Mar 14 2013 Jeff Law <law@redhat.com> - 4.7-8
  - Fix decoding of MADV_DODUMP and MADV_DONTDUMP (#921550)

* Wed Feb 26 2013 Jeff Law <law@redhat.com> - 4.7-7
  - Backport code to enable PTRACE_SEIZE which fixes race conditions
    at process startup. (#845004)

* Tue Feb 25 2013 Jeff Law <law@redhat.com> - 4.7-6
  - Forward port patch for #526740 to improve fairness in event handling
    (#851457)
  
* Mon Feb 25 2013 Jeff Law <law@redhat.com> - 4.7-5
  - Use the same type for i386_regs on 32-bit and 64-bit x86 (#915181)

* Wed Jan 30 2013 Jeff Law <law@redhat.com> - 4.7-4
  - Avoid strict aliasing warnings

* Wed Jan 30 2013 Jeff Law <law@redhat.com> - 4.7-3
  - Use .gz rather than .xz extension to work around
    DTS build problems.

* Wed Jan 30 2013 Jeff Law <law@redhat.com> - 4.7-2
  - Imported from F18/RHEL 7 into DTS.  Trim ChangeLog


